<template>
  <AtomAutocomplete
    :label="label"
    :name="name"
    :search-fn="searchCitiesFn"
    :value="selectedValue"
    :required="required"
    @result-selected="onSelectCity"
  />
</template>

<script setup>
  const { $request } = useNuxtApp()

  const props = defineProps({
    label: {
      type: String,
      required: true
    },
    name: {
      type: String,
      required: true
    },
    value: {
      type: String,
      default: ''
    },
    zipCode: {
      type: String,
      default: ''
    },
    required: {
      type: Boolean,
      default: false
    }
  })

  const emit = defineEmits(['citySelected'])

  const cities = ref([])
  const selectedValue = ref(props.value)

  watch(
    () => props.value,
    value => {
      selectedValue.value = value
    }
  )

  async function searchCitiesFn(search) {
    if (search.length < 3) return new Map()

    const params = new URLSearchParams({
      nom: search,
      limit: '3'
    })
    if (props.zipCode) params.append('codePostal', props.zipCode)

    const res = await $request(`https://geo.api.gouv.fr/communes?${params}`)

    if (res.status === 200) {
      cities.value = []
      /**
       * Big cities oftenly have multiple zip code.
       * The BAN API always returns the full list of zip codes associated to the city, even if a zip code is provided in the request.
       * Here, we get rid of other associated zip codes.
       */
      res.data.forEach(({ nom, codesPostaux, codeRegion }) => {
        codesPostaux.forEach(codePostal => {
          if (!props.zipCode || props.zipCode === codePostal) {
            cities.value.push({ nom, codePostal, codeRegion })
          }
        })
      })
      return new Map(
        cities.value.map(({ nom, codePostal }) => [
          codePostal,
          `${codePostal} ${nom}`
        ])
      )
    }
    throw new Error(res.data.errors[0].message)
  }

  function onSelectCity(codePostal) {
    const city = cities.value.find(a => a.codePostal === codePostal)
    if (!city) return
    selectedValue.value = city.nom
    emit('citySelected', {
      zipCode: city.codePostal,
      city: city.nom,
      codeRegion: city.codeRegion
    })
  }
</script>
